#!/usr/bin/env python

import sys, base64

VERSIONEER_b64 = """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"""
newver = "0.27"

VERSIONEER_PEP518 = True

VERSIONEER = base64.b64decode(VERSIONEER_b64.encode('ASCII'))


# Stub overwritten by exec()
def setup_command(): ...

# Make versioneer usable via import
exec(VERSIONEER.decode(), globals())


def detect_installed_version() -> str:
    """Find version string in vendored versioneer

    Raises FileNotFoundError if missing.
    """
    with open("versioneer.py") as fobj:
        for i, line in enumerate(fobj):
            if line.startswith("# Version: "):
                return line[len("# Version: "):].strip()
            if i > 5:
                break
    return "unknown version"


def vendor():
    """Install versioneer into current directory"""
    try:
        oldver = detect_installed_version()
    except FileNotFoundError:
        pass
    else:
        print(f"replacing old versioneer.py ({oldver})")

    with open("versioneer.py", "wb") as fobj:
        fobj.write(VERSIONEER)
    print(f"versioneer.py ({newver}) installed into local tree")


def main():
    usage = "Usage: versioneer install [--vendor|--no-vendor]"
    if len(sys.argv) < 2 or len(sys.argv) > 3:
        print(usage)
        sys.exit(1)

    command = sys.argv[1]
    mode = "--vendor" if len(sys.argv) == 2 else sys.argv[2]

    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)
    elif command in ("help", "-help", "--help"):
        print(usage)
        sys.exit(0)
    elif command != "install" or mode not in ("--vendor", "--no-vendor"):
        print(usage)
        sys.exit(1)

    if mode == "--vendor":
        vendor()
        print("Now running 'versioneer.py setup' to install the generated files..")

    setup_command()


if __name__ == '__main__':
    main()
